# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_common_msgs/CameraParam.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_common_msgs.msg
import std_msgs.msg

class CameraParam(genpy.Message):
  _md5sum = "f8f4160a10bad7e1ca60da3f1e56e284"
  _type = "rc_common_msgs/CameraParam"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Camera parameters that relate to a published image

# Header with timestamp and frame_id to which the parameters belong
Header header

# True in case of a color camera
bool is_color_camera

# Exposure time of the camera in seconds
float32 exposure_time

# Gain factor in dB
float32 gain

# Line status for DigitalIO control according to GenICam SFNC:
# Current status of all available line signals in a single bitfield
uint32 line_status_all

# Line sources for DigitalIO control according to GenICam SFNC:
# Specifies for each line which internal acquisition or I/O source
# signal is output on the respective line.
#
# The keys define the lines, the values define the sources; e.g.
# [ {key: "out1", value: "ExposureActive"},
#   {key: "out2", value: "Low"},
#   ...
# ]
#
KeyValue[] line_source

# Additional optional camera paramters as key value pairs
KeyValue[] extra_data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: rc_common_msgs/KeyValue
string key
string value
"""
  __slots__ = ['header','is_color_camera','exposure_time','gain','line_status_all','line_source','extra_data']
  _slot_types = ['std_msgs/Header','bool','float32','float32','uint32','rc_common_msgs/KeyValue[]','rc_common_msgs/KeyValue[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,is_color_camera,exposure_time,gain,line_status_all,line_source,extra_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CameraParam, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.is_color_camera is None:
        self.is_color_camera = False
      if self.exposure_time is None:
        self.exposure_time = 0.
      if self.gain is None:
        self.gain = 0.
      if self.line_status_all is None:
        self.line_status_all = 0
      if self.line_source is None:
        self.line_source = []
      if self.extra_data is None:
        self.extra_data = []
    else:
      self.header = std_msgs.msg.Header()
      self.is_color_camera = False
      self.exposure_time = 0.
      self.gain = 0.
      self.line_status_all = 0
      self.line_source = []
      self.extra_data = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2fI().pack(_x.is_color_camera, _x.exposure_time, _x.gain, _x.line_status_all))
      length = len(self.line_source)
      buff.write(_struct_I.pack(length))
      for val1 in self.line_source:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.extra_data)
      buff.write(_struct_I.pack(length))
      for val1 in self.extra_data:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.line_source is None:
        self.line_source = None
      if self.extra_data is None:
        self.extra_data = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.is_color_camera, _x.exposure_time, _x.gain, _x.line_status_all,) = _get_struct_B2fI().unpack(str[start:end])
      self.is_color_camera = bool(self.is_color_camera)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.line_source = []
      for i in range(0, length):
        val1 = rc_common_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.line_source.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extra_data = []
      for i in range(0, length):
        val1 = rc_common_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.extra_data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2fI().pack(_x.is_color_camera, _x.exposure_time, _x.gain, _x.line_status_all))
      length = len(self.line_source)
      buff.write(_struct_I.pack(length))
      for val1 in self.line_source:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.extra_data)
      buff.write(_struct_I.pack(length))
      for val1 in self.extra_data:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.line_source is None:
        self.line_source = None
      if self.extra_data is None:
        self.extra_data = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.is_color_camera, _x.exposure_time, _x.gain, _x.line_status_all,) = _get_struct_B2fI().unpack(str[start:end])
      self.is_color_camera = bool(self.is_color_camera)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.line_source = []
      for i in range(0, length):
        val1 = rc_common_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.line_source.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extra_data = []
      for i in range(0, length):
        val1 = rc_common_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.extra_data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B2fI = None
def _get_struct_B2fI():
    global _struct_B2fI
    if _struct_B2fI is None:
        _struct_B2fI = struct.Struct("<B2fI")
    return _struct_B2fI
