# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_common_msgs/ReturnCodeConstants.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ReturnCodeConstants(genpy.Message):
  _md5sum = "6c01807f8c18074c0d86fa2f1b874e6b"
  _type = "rc_common_msgs/ReturnCodeConstants"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message file defines commonly used constants
# for services' return codes

#  Default success without additional information
int16 SUCCESS=0

# Reserved error codes (reserved range [-99,-1])
int16 INVALID_ARGUMENT=-1   # An invalid argument was passed with the service request
int16 INTERNAL_ERROR=-2     # Internal error
int16 INTERNAL_TIMEOUT=-3   # Timeout in internal computation
int16 SENSOR_TIMEOUT=-4     # Timeout while waiting for image data to fulfill a request
int16 IO_ERROR=-7           # IO error
int16 NOT_APPLICABLE=-8     # Request not applicable (e.g. in current state)
int16 INVALID_LICENSE=-9    # No valid license to fulfill this request
int16 CAPACITY_EXCEEDED=-10 # capacity exceeded, i.e. new element could not be added

# Reserved non-error codes (reserved range [1,99])
int16 TIMEOUT_REACHED=3     # timeout in internal computation is reached, but a partial result could still be provided
int16 CAPACITY_REACHED=10   # max capacity is reached, i.e. list is now full
int16 OVERWRITTEN=11        # existing data/element overwritten
int16 HINTS=999             # performance/implementation hints for application developers

# each module defines own msg-file with consts for the module specific return codes
"""
  # Pseudo-constants
  SUCCESS = 0
  INVALID_ARGUMENT = -1
  INTERNAL_ERROR = -2
  INTERNAL_TIMEOUT = -3
  SENSOR_TIMEOUT = -4
  IO_ERROR = -7
  NOT_APPLICABLE = -8
  INVALID_LICENSE = -9
  CAPACITY_EXCEEDED = -10
  TIMEOUT_REACHED = 3
  CAPACITY_REACHED = 10
  OVERWRITTEN = 11
  HINTS = 999

  __slots__ = []
  _slot_types = []

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ReturnCodeConstants, self).__init__(*args, **kwds)

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
